'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _redux = require('redux');

var _reactRedux = require('react-redux');

var _devui = require('devui');

var _actions = require('../../actions');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var defaultSchema = {
  type: 'object',
  required: [],
  properties: {
    type: {
      title: 'Connection settings (for getting reports and remote debugging)',
      type: 'string',
      enum: ['disabled', 'remotedev', 'custom'],
      enumNames: ['no remote connection', 'connect via remotedev.io', 'use local (custom) server']
    },
    hostname: {
      type: 'string'
    },
    port: {
      type: 'number'
    },
    secure: {
      type: 'boolean'
    }
  }
};

var uiSchema = {
  type: {
    'ui:widget': 'radio'
  }
};

var Connection = (_temp = _class = function (_Component) {
  _inherits(Connection, _Component);

  function Connection(props) {
    _classCallCheck(this, Connection);

    var _this = _possibleConstructorReturn(this, (Connection.__proto__ || Object.getPrototypeOf(Connection)).call(this, props));

    _this.handleSave = function (data) {
      _this.props.saveSettings(data.formData);
      _this.setState({ changed: false });
    };

    _this.setFormData = function (type, changed) {
      var schema = void 0;
      if (type !== 'custom') {
        schema = {
          type: 'object',
          properties: { type: defaultSchema.properties.type }
        };
      } else {
        schema = defaultSchema;
      }
      return {
        formData: _extends({
          type: type
        }, _this.props.options),
        type: type,
        schema: schema,
        changed: changed
      };
    };

    _this.handleChange = function (data) {
      var formData = data.formData;
      var type = formData.type;
      if (type !== _this.state.type) {
        _this.setState(_this.setFormData(type, true));
      } else if (!_this.state.changed) {
        _this.setState({ changed: true, formData: formData });
      }
    };

    _this.state = _this.setFormData(props.type);
    return _this;
  }

  _createClass(Connection, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      return this.state !== nextState;
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (this.props.options !== nextProps.options) {
        this.setState({ formData: _extends({}, nextProps.options, { type: nextProps.type }) });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var type = this.state.type || 'disabled';
      var changed = this.state.changed;
      var disabled = type === 'disabled';

      return _react2.default.createElement(
        _devui.Container,
        null,
        _react2.default.createElement(_devui.Form, {
          primaryButton: changed,
          noSubmit: disabled && !changed,
          submitText: disabled ? 'Disconnect' : 'Connect',
          formData: this.state.formData,
          schema: this.state.schema,
          uiSchema: uiSchema,
          onChange: this.handleChange,
          onSubmit: this.handleSave
        })
      );
    }
  }]);

  return Connection;
}(_react.Component), _class.propTypes = {
  saveSettings: _react.PropTypes.func.isRequired,
  options: _react.PropTypes.object.isRequired,
  type: _react.PropTypes.string
}, _temp);


function mapStateToProps(state) {
  return state.connection;
}

function mapDispatchToProps(dispatch) {
  return {
    saveSettings: (0, _redux.bindActionCreators)(_actions.saveSocketSettings, dispatch)
  };
}

exports.default = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(Connection);
module.exports = exports['default'];