'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _redux = require('redux');

var _reactRedux = require('react-redux');

var _devui = require('devui');

var _Slider = require('./monitors/Slider');

var _Slider2 = _interopRequireDefault(_Slider);

var _actions = require('../actions');

var _instances = require('../reducers/instances');

var _DevTools = require('../containers/DevTools');

var _DevTools2 = _interopRequireDefault(_DevTools);

var _Dispatcher = require('./monitors/Dispatcher');

var _Dispatcher2 = _interopRequireDefault(_Dispatcher);

var _TopButtons = require('../components/TopButtons');

var _TopButtons2 = _interopRequireDefault(_TopButtons);

var _BottomButtons = require('../components/BottomButtons');

var _BottomButtons2 = _interopRequireDefault(_BottomButtons);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Actions = function (_Component) {
  _inherits(Actions, _Component);

  function Actions() {
    _classCallCheck(this, Actions);

    return _possibleConstructorReturn(this, (Actions.__proto__ || Object.getPrototypeOf(Actions)).apply(this, arguments));
  }

  _createClass(Actions, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          monitor = _props.monitor,
          dispatcherIsOpen = _props.dispatcherIsOpen,
          sliderIsOpen = _props.sliderIsOpen,
          options = _props.options,
          liftedState = _props.liftedState,
          liftedDispatch = _props.liftedDispatch;

      return _react2.default.createElement(
        _devui.Container,
        null,
        _react2.default.createElement(_TopButtons2.default, {
          dispatch: liftedDispatch,
          liftedState: liftedState,
          options: options
        }),
        _react2.default.createElement(_DevTools2.default, {
          monitor: monitor,
          liftedState: liftedState,
          monitorState: this.props.monitorState,
          dispatch: liftedDispatch,
          features: options.features
        }),
        sliderIsOpen && options.connectionId && options.features.jump && _react2.default.createElement(_Slider2.default, { liftedState: liftedState, dispatch: liftedDispatch }),
        dispatcherIsOpen && options.connectionId && options.features.dispatch && _react2.default.createElement(_Dispatcher2.default, { options: options }),
        _react2.default.createElement(_BottomButtons2.default, {
          dispatcherIsOpen: dispatcherIsOpen,
          sliderIsOpen: sliderIsOpen,
          options: options
        })
      );
    }
  }]);

  return Actions;
}(_react.Component);

Actions.propTypes = {
  liftedDispatch: _react.PropTypes.func.isRequired,
  liftedState: _react.PropTypes.object.isRequired,
  monitorState: _react.PropTypes.object,
  options: _react.PropTypes.object.isRequired,
  monitor: _react.PropTypes.string,
  dispatcherIsOpen: _react.PropTypes.bool,
  sliderIsOpen: _react.PropTypes.bool
};

function mapStateToProps(state) {
  var instances = state.instances;
  var id = (0, _instances.getActiveInstance)(instances);
  return {
    liftedState: instances.states[id],
    monitorState: state.monitor.monitorState,
    options: instances.options[id],
    monitor: state.monitor.selected,
    dispatcherIsOpen: state.monitor.dispatcherIsOpen,
    sliderIsOpen: state.monitor.sliderIsOpen,
    reports: state.reports.data
  };
}

function mapDispatchToProps(dispatch) {
  return {
    liftedDispatch: (0, _redux.bindActionCreators)(_actions.liftedDispatch, dispatch),
    getReport: (0, _redux.bindActionCreators)(_actions.getReport, dispatch)
  };
}

exports.default = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(Actions);
module.exports = exports['default'];